structure Tokens = Tokens
structure Interface = Interface
open Interface

type pos = Interface.pos
type svalue = Tokens.svalue
type ('a,'b) token = ('a,'b) Tokens.token
type lexresult= (svalue,pos) token

val eof = fn () => Tokens.EOF(!line,!line)
fun makeInt (s : string) = s

%%
%header (functor ExpLexFun(structure Tokens: Exp_TOKENS
			   structure Interface: INTERFACE) : LEXER);
ws=[\t\ ]*;
num=[0-9]+;
id=[A-Za-z_]([A-Za-z_0-9]*);
%%
<INITIAL>{ws}	=> (lex());
<INITIAL>\n	    => (next_line(); lex());
<INITIAL>","	=> (Tokens.COMMA(!line,!line));
<INITIAL>"."    => (Tokens.DOT(!line,!line));
<INITIAL>"("	=> (Tokens.LPAREN(!line,!line));
<INITIAL>")"	=> (Tokens.RPAREN(!line,!line));
<INITIAL>"="	=> (Tokens.EQ(!line,!line));
<INITIAL>{id}   => (if yytext = "let" then Tokens.LET (!line,!line)
					else if yytext = "lam" then Tokens.LAM (!line,!line)
					else if yytext = "in" then Tokens.IN (!line,!line)
					else Tokens.ID (yytext,!line,!line));
<INITIAL>{num}	=> (Tokens.INT (getOpt (Int.fromString yytext, ~1),!line,!line));
<INITIAL>.	=> (error ("ignoring illegal character" ^ yytext,
			   !line,!line); lex());
